{% extends 'base.html.twig' %}

{% block title %}Hello DashboardController!
{% endblock %}

{% block stylesheets %}
	{{parent()}}
	<link rel="stylesheet" href="{{asset('assets/css/material-design-icons.min.css')}}">
{% endblock %}

{% block body %}
	{% verbatim %}
		<div class="app">
			<div class="w-full bg-hd-deep-teal">
				<div class="container max-w-desktop mx-auto bg-hd-deep-teal">
					<nav class="h-[80px] flex">
                        <div class="flex flex-row">
                            <div class="flex flex-row items-center" v-if="filterFromCurrentData('dBm')">
                                <rssi :value="filterFromCurrentData('dBm')">
                            </div>
                            <div class="flex ml-2 flex-row items-center" v-if="filterFromCurrentData('V')">
                                <voltage :value="filterFromCurrentData('V')">
                            </div>
                        </div>
						<div class="relative flex flex-col ml-auto">
							<div :class="[showLocations ? 'bg-gray-600' : 'bg-hd-deeper-teal']" class="-auto h-full p-8 hover:bg-gray-600 flex items-center text-white relative flex flex-col relative" @mouseover="showLocations = true" @mouseleave="showLocations = false">
								{{location.name}}
								<span v-show="!showLocations" class="mdi mdi-chevron-down"></span>
							</div>
							<ul class="text-center" v-show="showLocations" v-for="location in remainingLocations" @mouseover="showLocations = true" @mouseleave="showLocations = false">
								<li class="py-2 bg-hd-deeper-teal hover:bg-gray-600 text-white cursor-pointer" @click="setLocation(location.id)">{{location.name}}</li>
							</div>
						</div>
					</nav>
				</div>
                <div class="container max-w-desktop mx-auto">
                    <div class="flex grid grid-flow-row-dense grid-cols-12 grid-rows-1 gap-4 mt-4">
                        <div class='col-span-3'>
                            <currentdatabox :data="currentDataBoxData" />
                        </div>
                        <div class='col-span-4'>
                            <pastdatesvalues :values="previousData" />
                        </div>
                        <div class='col-span-5'>
                            <Stats :values="statsData" />
                        </div>
                    </div>
                </div>
                <div class="container desktop:max-w-desktop mx-auto mt-4 p-4 bg-hd-light-silver">
				    <div class="grid flex grid-cols-1 desktop:grid-cols-3">
                        <div>
                            <Weather :data="weatherData"/>
                        </div>
                        <div class="col-span-2">
                            <div class="flex flex-col">
                                <strong class="text-2xl uppercase">Dnes</strong>
                                <TodayMinMaxData :data="todayData"/>
                            </div>
                        </div>
				    </div>
                </div>
                <div v-if="todayChartData.data">
                    <vue-chart v-if="todayChartData" type="line" :data="todayChartData.data" :options="todayChartData.options"></vue-chart>
                </div>
			</div>
			</div>
		</div>
	{% endverbatim %}
{% endblock %}

{% block javascripts %}
	{{parent()}}
	<script type="module" src="{{asset('assets/js/hooks/useStorageLocation.js')}}"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/es5-shim/4.5.14/es5-sham.min.js"></script>
    {# <script src="{{asset('assets/js/components/Rssi.js')}}"></script> #}
    {# <script src="{{asset('assets/js/components/Voltage.js')}}"></script> #}
    {# <script src="{{asset('assets/js/components/CurrentDataBoxData.js')}}"></script> #}
    <script src="{{asset('assets/js/functions/valueBackground.js')}}"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.7.0/Chart.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/vue-chart-js@1.4.1/dist/vue-chart-js.min.js"></script>
	<script>
        Vue.use(VueChart.default)
    </script>
    <script type="module">
		import UseStorageLocation from "{{ asset('assets/js/hooks/useStorageLocation.js') }}";
        import CurrentDataBoxData from "/assets/js/components/CurrentDataBoxData.js";
        import Voltage from "/assets/js/components/Voltage.js";
        import Rssi from "/assets/js/components/Rssi.js";
        import PastDatesValues from "/assets/js/components/PastDatesValues.js";
        import Stats from "/assets/js/components/Stats.js";
        import Weather from "/assets/js/components/Weather.js";
        import TodayMinMaxData from "/assets/js/components/TodayMinMaxData.js";

        var locations = {{ locations|json_encode()|raw }};
        var storageLocation = UseStorageLocation();
        var app = new Vue({
            el: '.app',
            components: {
                "currentdatabox": CurrentDataBoxData,
                "rssi": Rssi,
                "Voltage": Voltage,
                "pastdatesvalues": PastDatesValues,
                "stats": Stats,
                "weather": Weather,
                "todayminmaxdata": TodayMinMaxData
            },
            data() {
                return {
                    domainsInContent: [
                        'temperature',
                        'humidity',
                        'tv',
                        'pressure',
                        'illuminance',
                        'dewpoint'
                    ],
                    locations: locations,
                    location: locations[storageLocation.getCurrentLocation() - 1] || locations[0],
                    showLocations: false,
                    currentData: [], 
                    navigationCurrentData: [],
                    currentDataContent: [],
                    previousData: {},
                    weatherData: {},
                    statsData: [],
                    todayData: {},
                    todayChartData: {},
                };
            },
            methods: {
                setLocation(id) {
                    storageLocation.setLocation(id);
                    this.location = this.locations[id - 1];
                    this.showLocations = false;
                },
                filterFromCurrentData(unit) {
                    const filter = this.currentData.find(data => data.unit === unit);

                    if (!this.navigationCurrentData.includes(unit)){
                        this.navigationCurrentData?.push(unit);
                    }

                    return filter;
                },
                async fetchData(routeKey) {
                    const response = await axios.post(meteo.routes[routeKey], {
                        id: this.location.id
                    });
                
                return response.data;
                },
                async  fetchDataForLocation(locationId) {
                    this.currentData = await this.fetchData('current_data', locationId);
                    this.previousData = await this.fetchData('previous_data', locationId);
                    this.statsData = await this.fetchData('stats_data', locationId);
                    this.weatherData = await this.fetchData('weather_data', locationId);
                    this.todayData = await this.fetchData('today_data', locationId);
                    
                    const chartDataRaw = await this.fetchData('today_chart_data', locationId);
                    chartDataRaw.data = JSON.parse(chartDataRaw.data);
                    chartDataRaw.options = JSON.parse(chartDataRaw.options);
                    if (chartDataRaw.data){
                        console.log('chartData', chartDataRaw);
                        this.todayChartData = chartDataRaw;
                    }
                }
            },
            computed: {
                remainingLocations() {
                    return this.locations.filter(location => location['id'] !== this.location['id'])
                },
                currentDataBoxData() {
                    const toReturn = this.currentData.filter(item => this.domainsInContent.includes(item.domain));
                    return this.currentData.filter(item => this.domainsInContent.includes(item.domain));
                }
            },
            watch: {
              
            },
            async mounted() {
                await this.fetchDataForLocation(this.location.id);
            }
        });

        Vue.component('rssi', Rssi)
        Vue.component('voltage', Voltage)
        Vue.component('currentdatabox', CurrentDataBoxData)
        Vue.component('pastdatesvalues', PastDatesValues)
        Vue.component('stas', Stats)
        Vue.component('weather', Weather)
        Vue.component('todayMinMaxData', TodayMinMaxData)       
	</script>
{% endblock %}
